org.glassfish.jersey.logging

## Class LoggingFeature

- java.lang.Object
- - org.glassfish.jersey.logging.LoggingFeature

All Implemented Interfaces:
  jakarta.ws.rs.core.Feature

    public class LoggingFeature
    extends Object
    implements jakarta.ws.rs.core.Feature

This feature enables logging request and/or response on client-side and/or server-side depending on the context's `RuntimeType`.

The feature may be register programmatically like other features by calling any of `Configurable` `register(...)` method, i.e. `Configurable.register(Class)` or by setting any of the configuration property listed bellow.

Common configurable properties applies for both client and server and are following:

- `LOGGING_FEATURE_LOGGER_NAME`
- `LOGGING_FEATURE_LOGGER_LEVEL`
- `LOGGING_FEATURE_VERBOSITY`
- `LOGGING_FEATURE_MAX_ENTITY_SIZE`

If any of the configuration value is not set, following default values are applied:

- logger name: `org.glassfish.jersey.logging.LoggingFeature`
- logger level: `Level.FINE`
- verbosity: `LoggingFeature.Verbosity.PAYLOAD_TEXT`
- maximum entity size: 8192

Server configurable properties:

- `LOGGING_FEATURE_LOGGER_NAME_SERVER`
- `LOGGING_FEATURE_LOGGER_LEVEL_SERVER`
- `LOGGING_FEATURE_VERBOSITY_SERVER`
- `LOGGING_FEATURE_MAX_ENTITY_SIZE_SERVER`

Client configurable properties:

- `LOGGING_FEATURE_LOGGER_NAME_CLIENT`
- `LOGGING_FEATURE_LOGGER_LEVEL_CLIENT`
- `LOGGING_FEATURE_VERBOSITY_CLIENT`
- `LOGGING_FEATURE_MAX_ENTITY_SIZE_CLIENT`

Since:
  2.23
Author:
  Ondrej Kosatka

### Nested Class Summary

Nested Classes
`static class` `LoggingFeature.Verbosity` `Verbosity` determines how detailed message will be logged.

### Field Summary

Fields
`static String` `DEFAULT_LOGGER_LEVEL` Default logger level which will be used for logging request and response messages.
`static String` `DEFAULT_LOGGER_NAME` Default logger name to log request and response messages.
`static int` `DEFAULT_MAX_ENTITY_SIZE` Default maximum entity bytes to be logged.
`static LoggingFeature.Verbosity` `DEFAULT_VERBOSITY` Default verbosity for entity logging.
`static String` `LOGGING_FEATURE_LOGGER_LEVEL` Common logger level property.
`static String` `LOGGING_FEATURE_LOGGER_LEVEL_CLIENT` Client logger level property.
`static String` `LOGGING_FEATURE_LOGGER_LEVEL_SERVER` Server logger level property.
`static String` `LOGGING_FEATURE_LOGGER_NAME` Common logger name property.
`static String` `LOGGING_FEATURE_LOGGER_NAME_CLIENT` Client logger name property.
`static String` `LOGGING_FEATURE_LOGGER_NAME_SERVER` Server logger name property.
`static String` `LOGGING_FEATURE_MAX_ENTITY_SIZE` Common property for configuring a maximum number of bytes of entity to be logged.
`static String` `LOGGING_FEATURE_MAX_ENTITY_SIZE_CLIENT` Client property for configuring a maximum number of bytes of entity to be logged.
`static String` `LOGGING_FEATURE_MAX_ENTITY_SIZE_SERVER` Server property for configuring a maximum number of bytes of entity to be logged.
`static String` `LOGGING_FEATURE_VERBOSITY` Common property for configuring a verbosity of entity.
`static String` `LOGGING_FEATURE_VERBOSITY_CLIENT` Client property for configuring a verbosity of entity.
`static String` `LOGGING_FEATURE_VERBOSITY_SERVER` Server property for configuring a verbosity of entity.

### Constructor Summary

Constructors
Constructor and Description
`LoggingFeature()` Creates the feature with default values.
`LoggingFeature(Logger logger)` Creates the feature with custom logger.
`LoggingFeature(Logger logger, Integer maxEntitySize)` Creates the feature with custom logger and maximum number of bytes of entity to log.
`LoggingFeature(Logger logger, Level level, LoggingFeature.Verbosity verbosity, Integer maxEntitySize)` Creates the feature with custom logger, it's level, message verbosity and maximum number of bytes of entity to log.
`LoggingFeature(Logger logger, LoggingFeature.Verbosity verbosity)` Creates the feature with custom logger and verbosity.

### Method Summary

All Methods Instance Methods Concrete Methods
`boolean` `configure(jakarta.ws.rs.core.FeatureContext context)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### DEFAULT_LOGGER_NAME

    public static final String DEFAULT_LOGGER_NAME

Default logger name to log request and response messages.

#### DEFAULT_LOGGER_LEVEL

    public static final String DEFAULT_LOGGER_LEVEL

Default logger level which will be used for logging request and response messages.

#### DEFAULT_MAX_ENTITY_SIZE

    public static final int DEFAULT_MAX_ENTITY_SIZE

Default maximum entity bytes to be logged.

See Also:
  Constant Field Values

#### DEFAULT_VERBOSITY

    public static final LoggingFeature.Verbosity DEFAULT_VERBOSITY

Default verbosity for entity logging. See `LoggingFeature.Verbosity`.

#### LOGGING_FEATURE_LOGGER_NAME

    public static final String LOGGING_FEATURE_LOGGER_NAME

Common logger name property.

See Also:
  Constant Field Values

#### LOGGING_FEATURE_LOGGER_LEVEL

    public static final String LOGGING_FEATURE_LOGGER_LEVEL

Common logger level property.

See Also:
  Constant Field Values

#### LOGGING_FEATURE_VERBOSITY

    public static final String LOGGING_FEATURE_VERBOSITY

Common property for configuring a verbosity of entity.

See Also:
  Constant Field Values

#### LOGGING_FEATURE_MAX_ENTITY_SIZE

    public static final String LOGGING_FEATURE_MAX_ENTITY_SIZE

Common property for configuring a maximum number of bytes of entity to be logged.

See Also:
  Constant Field Values

#### LOGGING_FEATURE_LOGGER_NAME_SERVER

    public static final String LOGGING_FEATURE_LOGGER_NAME_SERVER

Server logger name property.

See Also:
  Constant Field Values

#### LOGGING_FEATURE_LOGGER_LEVEL_SERVER

    public static final String LOGGING_FEATURE_LOGGER_LEVEL_SERVER

Server logger level property.

See Also:
  Constant Field Values

#### LOGGING_FEATURE_VERBOSITY_SERVER

    public static final String LOGGING_FEATURE_VERBOSITY_SERVER

Server property for configuring a verbosity of entity.

See Also:
  Constant Field Values

#### LOGGING_FEATURE_MAX_ENTITY_SIZE_SERVER

    public static final String LOGGING_FEATURE_MAX_ENTITY_SIZE_SERVER

Server property for configuring a maximum number of bytes of entity to be logged.

See Also:
  Constant Field Values

#### LOGGING_FEATURE_LOGGER_NAME_CLIENT

    public static final String LOGGING_FEATURE_LOGGER_NAME_CLIENT

Client logger name property.

See Also:
  Constant Field Values

#### LOGGING_FEATURE_LOGGER_LEVEL_CLIENT

    public static final String LOGGING_FEATURE_LOGGER_LEVEL_CLIENT

Client logger level property.

See Also:
  Constant Field Values

#### LOGGING_FEATURE_VERBOSITY_CLIENT

    public static final String LOGGING_FEATURE_VERBOSITY_CLIENT

Client property for configuring a verbosity of entity.

See Also:
  Constant Field Values

#### LOGGING_FEATURE_MAX_ENTITY_SIZE_CLIENT

    public static final String LOGGING_FEATURE_MAX_ENTITY_SIZE_CLIENT

Client property for configuring a maximum number of bytes of entity to be logged.

See Also:
  Constant Field Values

### Constructor Detail

#### LoggingFeature

    public LoggingFeature()

Creates the feature with default values.

#### LoggingFeature

    public LoggingFeature(Logger logger)

Creates the feature with custom logger.

Parameters:
  `logger` - the logger to log requests and responses.

#### LoggingFeature

    public LoggingFeature(Logger logger,
                          LoggingFeature.Verbosity verbosity)

Creates the feature with custom logger and verbosity.

Parameters:
  `logger` - the logger to log requests and responses.
  `verbosity` - verbosity of logged messages. See `LoggingFeature.Verbosity`.

#### LoggingFeature

    public LoggingFeature(Logger logger,
                          Integer maxEntitySize)

Creates the feature with custom logger and maximum number of bytes of entity to log.

Parameters:
  `logger` - the logger to log requests and responses.
  `maxEntitySize` - maximum number of entity bytes to be logged (and buffered) - if the entity is larger, logging filter will print (and buffer in memory) only the specified number of bytes and print "...more..." string at the end. Negative values are interpreted as zero.

#### LoggingFeature

    public LoggingFeature(Logger logger,
                          Level level,
                          LoggingFeature.Verbosity verbosity,
                          Integer maxEntitySize)

Creates the feature with custom logger, it's level, message verbosity and maximum number of bytes of entity to log.

Parameters:
  `logger` - the logger to log requests and responses.
  `level` - level on which the messages will be logged.
  `verbosity` - verbosity of logged messages. See `LoggingFeature.Verbosity`.
  `maxEntitySize` - maximum number of entity bytes to be logged (and buffered) - if the entity is larger, logging filter will print (and buffer in memory) only the specified number of bytes and print "...more..." string at the end. Negative values are interpreted as zero.

### Method Detail

#### configure

    public boolean configure(jakarta.ws.rs.core.FeatureContext context)

Specified by:
  `configure` in interface `jakarta.ws.rs.core.Feature`